## highway 0.12.2+git20210722

=== debian/changelog ===
highway (0.12.2+git20210722-1~mx21+1) mx; urgency=medium

  * Initial packaging for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 25 Jul 2021 00:41:13 -0400

highway (0.12.2-1) UNRELEASED; urgency=medium

  * fix scalar-only test and Windows macro conflict with Load/StoreFence
  * replace deprecated wasm intrinsics

 -- Jan Wassenberg <janwas@google.com>  Mon, 31 May 2021 16:00:00 +0200

highway (0.12.1-1) UNRELEASED; urgency=medium

  * doc updates, ARM GCC support, fix s390/ppc, complete partial vectors
  * fix warnings, faster ARM div/sqrt, separate hwy_contrib library
  * add Abs(i64)/FirstN/Pause, enable AVX2 on MSVC

 -- Jan Wassenberg <janwas@google.com>  Wed, 19 May 2021 15:00:00 +0200

highway (0.12.0-1) UNRELEASED; urgency=medium

  * Add Shift*8, Compress16, emulated Scatter/Gather, StoreInterleaved3/4
  * Remove deprecated HWY_*_LANES, deprecate HWY_GATHER_LANES
  * Proper IEEE rounding, reduce libstdc++ usage, inlined math

 -- Jan Wassenberg <janwas@google.com>  Thu, 15 Apr 2021 20:00:00 +0200

highway (0.11.1-1) UNRELEASED; urgency=medium

  * Fix clang7 asan error, finish f16 conversions and add test

 -- Jan Wassenberg <janwas@google.com>  Thu, 25 Feb 2021 16:00:00 +0200

highway (0.11.0-1) UNRELEASED; urgency=medium

  * Add RVV+mask logical ops, allow Shl/ShiftLeftSame on all targets, more math

 -- Jan Wassenberg <janwas@google.com>  Thu, 18 Feb 2021 20:00:00 +0200

highway (0.7.0-1) UNRELEASED; urgency=medium

  * Added API stability notice, Compress[Store], contrib/, SignBit, CopySign

 -- Jan Wassenberg <janwas@google.com>  Tue, 5 Jan 2021 17:00:00 +0200

highway (0.1-1) UNRELEASED; urgency=medium

  * Initial debian package.

 -- Alex Deymo <deymo@google.com>  Mon, 19 Oct 2020 16:48:07 +0200
