## highway 0.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
   cmake_policy(SET CMP0083 NEW)
 endif()
 
-project(hwy VERSION 0.12.2)  # Keep in sync with highway.h version
+project(hwy VERSION 0.15.0)  # Keep in sync with highway.h version
 
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -41,6 +41,12 @@
 endif()
 
 set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for ARMv7 with NEON?")
+
+# Unconditionally adding -Werror risks breaking the build when new warnings
+# arise due to compiler/platform changes. Enable this in CI/tests.
+set(HWY_WARNINGS_ARE_ERRORS OFF CACHE BOOL "Add -Werror flag?")
+
+set(HWY_EXAMPLES_TESTS_INSTALL ON CACHE BOOL "Build examples, tests, install?")
 
 include(CheckCXXSourceCompiles)
 check_cxx_source_compiles(
@@ -54,9 +60,11 @@
 )
 
 set(HWY_CONTRIB_SOURCES
+    hwy/contrib/dot/dot-inl.h
     hwy/contrib/image/image.cc
     hwy/contrib/image/image.h
     hwy/contrib/math/math-inl.h
+    hwy/contrib/sort/sort-inl.h
 )
 
 set(HWY_SOURCES
@@ -82,7 +90,13 @@
     hwy/ops/x86_512-inl.h
     hwy/targets.cc
     hwy/targets.h
+)
+
+set(HWY_TEST_SOURCES
+    hwy/tests/hwy_gtest.h
     hwy/tests/test_util-inl.h
+    hwy/tests/test_util.cc
+    hwy/tests/test_util.h
 )
 
 if (MSVC)
@@ -101,11 +115,11 @@
     # Warnings
     -Wall
     -Wextra
-    -Wformat-security
-    -Wno-unused-function
+    # These are not included in Wall nor Wextra:
+    -Wconversion
+    -Wsign-conversion
+    -Wvla
     -Wnon-virtual-dtor
-    -Woverloaded-virtual
-    -Wvla
   )
 
   if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
@@ -134,29 +148,34 @@
   endif()
 
   if (WIN32)
+    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
+      list(APPEND HWY_FLAGS
+        -Wno-global-constructors
+        -Wno-language-extension-token
+        -Wno-used-but-marked-unused
+        -Wno-shadow-field-in-constructor
+        -Wno-unused-member-function
+        -Wno-unused-template
+        -Wno-c++98-compat-pedantic
+        -Wno-used-but-marked-unused
+        -Wno-zero-as-null-pointer-constant
+      )
+    endif()
+
     list(APPEND HWY_FLAGS
-      -Wno-c++98-compat-pedantic
       -Wno-cast-align
       -Wno-double-promotion
       -Wno-float-equal
       -Wno-format-nonliteral
-      -Wno-global-constructors
-      -Wno-language-extension-token
-      -Wno-missing-prototypes
       -Wno-shadow
-      -Wno-shadow-field-in-constructor
       -Wno-sign-conversion
-      -Wno-unused-member-function
-      -Wno-unused-template
-      -Wno-used-but-marked-unused
-      -Wno-zero-as-null-pointer-constant
     )
   else()
     list(APPEND HWY_FLAGS
       -fmath-errno
       -fno-exceptions
     )
-  endif()
+  endif()  # WIN32
 
   if (HWY_CMAKE_ARM7)
     list(APPEND HWY_FLAGS
@@ -167,6 +186,10 @@
     )
   endif()  # HWY_CMAKE_ARM7
 
+  if (HWY_WARNINGS_ARE_ERRORS)
+    list(APPEND HWY_FLAGS -Werror)
+  endif()
+
 endif()  # !MSVC
 
 add_library(hwy STATIC ${HWY_SOURCES})
@@ -178,28 +201,31 @@
 target_compile_options(hwy_contrib PRIVATE ${HWY_FLAGS})
 set_property(TARGET hwy_contrib PROPERTY POSITION_INDEPENDENT_CODE ON)
 target_include_directories(hwy_contrib PUBLIC ${CMAKE_CURRENT_LIST_DIR})
+
+add_library(hwy_test STATIC ${HWY_TEST_SOURCES})
+target_compile_options(hwy_test PRIVATE ${HWY_FLAGS})
+set_property(TARGET hwy_test PROPERTY POSITION_INDEPENDENT_CODE ON)
+target_include_directories(hwy_test PUBLIC ${CMAKE_CURRENT_LIST_DIR})
 
 # -------------------------------------------------------- hwy_list_targets
 # Generate a tool to print the compiled-in targets as defined by the current
 # flags. This tool will print to stderr at build time, after building hwy.
 add_executable(hwy_list_targets hwy/tests/list_targets.cc)
 target_compile_options(hwy_list_targets PRIVATE ${HWY_FLAGS})
+target_link_libraries(hwy_list_targets hwy)
 target_include_directories(hwy_list_targets PRIVATE
   $<TARGET_PROPERTY:hwy,INCLUDE_DIRECTORIES>)
 # TARGET_FILE always returns the path to executable
 # Naked target also not always could be run (due to the lack of '.\' prefix)
 # Thus effective command to run should contain the full path
 # and emulator prefix (if any).
-add_custom_command(TARGET hwy POST_BUILD
+add_custom_command(TARGET hwy_list_targets POST_BUILD
     COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:hwy_list_targets> || (exit 0))
 
 # --------------------------------------------------------
-# The following sections are skipped if this project is added via
-# add_subdirectory into parent project (i.e. used as library).
-# Those sections contain artifacts that are not required for building
-# parent project: tests, examples, benchmarks and installation.
-# --------------------------------------------------------
-if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
+# Allow skipping the following sections for projects that do not need them:
+# tests, examples, benchmarks and installation.
+if (HWY_EXAMPLES_TESTS_INSTALL)
 
 # -------------------------------------------------------- install library
 install(TARGETS hwy
@@ -219,6 +245,18 @@
 # Install all the headers keeping the relative path to the current directory
 # when installing them.
 foreach (source ${HWY_CONTRIB_SOURCES})
+  if ("${source}" MATCHES "\.h$")
+    get_filename_component(dirname "${source}" DIRECTORY)
+    install(FILES "${source}"
+        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${dirname}")
+  endif()
+endforeach()
+
+install(TARGETS hwy_test
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}")
+# Install all the headers keeping the relative path to the current directory
+# when installing them.
+foreach (source ${HWY_TEST_SOURCES})
   if ("${source}" MATCHES "\.h$")
     get_filename_component(dirname "${source}" DIRECTORY)
     install(FILES "${source}"
@@ -297,8 +335,12 @@
 endif() # HWY_SYSTEM_GTEST
 
 set(HWY_TEST_FILES
+  hwy/contrib/dot/dot_test.cc
   hwy/contrib/image/image_test.cc
+  # Disabled due to SIGILL in clang7 debug build during gtest discovery phase,
+  # not reproducible locally. Still tested via bazel build.
   # hwy/contrib/math/math_test.cc
+  hwy/contrib/sort/sort_test.cc
   hwy/aligned_allocator_test.cc
   hwy/base_test.cc
   hwy/highway_test.cc
@@ -327,30 +369,3 @@
   # policy to all-attainable; note that setting -DHWY_COMPILE_* directly can
   # cause compile errors because only one may be set, and other CMakeLists.txt
   # that include us may set them.
-  target_compile_options(${TESTNAME} PRIVATE -DHWY_IS_TEST=1)
-
-  if(HWY_SYSTEM_GTEST)
-    target_link_libraries(${TESTNAME} hwy hwy_contrib GTest::GTest GTest::Main)
-  else()
-    target_link_libraries(${TESTNAME} hwy hwy_contrib gtest gtest_main)
-  endif()
-  # Output test targets in the test directory.
-  set_target_properties(${TESTNAME} PROPERTIES PREFIX "tests/")
-
-  if (HWY_EMSCRIPTEN)
-    set_target_properties(${TESTNAME} PROPERTIES LINK_FLAGS "-s SINGLE_FILE=1")
-  endif()
-
-  if(${CMAKE_VERSION} VERSION_LESS "3.10.3")
-    gtest_discover_tests(${TESTNAME} TIMEOUT 60)
-  else ()
-    gtest_discover_tests(${TESTNAME} DISCOVERY_TIMEOUT 60)
-  endif ()
-endforeach ()
-
-# The skeleton test uses the skeleton library code.
-target_sources(skeleton_test PRIVATE hwy/examples/skeleton.cc)
-
-endif() # BUILD_TESTING
-
-endif() # CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
