=== debian/changelog ===
highway (0.15.0-5) unstable; urgency=medium

  * d/rules: Clarify that we only ship static libs for now
  * d/control: Add missing Rules-Requires-Root: no
  * d/patches: Remove compilation error on GNU/Hurd
  * d/rules: Set HWY_CMAKE_ARM7 to OFF. Closes: #1003218
  * d/patches: Fix compilation error on riscv64

 -- Mathieu Malaterre <malat@debian.org>  Tue, 11 Jan 2022 14:52:28 +0100

highway (0.15.0-4) unstable; urgency=medium

  * d/docs: Create new highway-doc package
  * d/rules: Do not set HWY_CMAKE_ARM7:ON for arm64
  * d/rules: Prefer building using cmake+ninja
  * d/rules: Properly setup HWY_CMAKE_ARM7 on armhf. Closes: #1003218

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Jan 2022 15:21:05 +0100

highway (0.15.0-3) unstable; urgency=medium

  * d/rules: Fix typo in cmake armhf/neon option
  * d/rules: Make sure to use neon extension on arm64
  * d/control: libhwy-dev could be marked Multi-Arch: same

 -- Mathieu Malaterre <malat@debian.org>  Thu, 06 Jan 2022 13:59:37 +0100

highway (0.15.0-2) unstable; urgency=medium

  * Upload to unstable
  * d/rules: Make sure to compile without warnings
  * d/rules: Start using arm7 neon extension
  * d/patches: Prefer default gcc c++ version

 -- Mathieu Malaterre <malat@debian.org>  Tue, 04 Jan 2022 15:45:40 +0100

highway (0.15.0-1) experimental; urgency=medium

  * Initial release (Closes: #1000984)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 02 Dec 2021 21:42:02 +0100
