=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake+ninja

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
  # https://github.com/google/highway/issues/495
  CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
endif

CMAKE_EXTRA_FLAGS += \
 -DBUILD_SHARED_LIBS:BOOL=OFF \
 -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
 -DHWY_SYSTEM_GTEST:BOOL=ON

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

override_dh_compress-indep:
	# do not compress .pdf/.md files for documentation
	dh_compress -X.md -X.pdf
