=== debian/changelog ===
highway (0.16.0-1) unstable; urgency=medium

  * d/rules: Make sure to check level 4 symbol file
  * d/symbols: Add symbol for 32bits arch
  * d/binaries: Specify path to PDF files
  * d/copyright: Update to latest year
  * d/compat: Bump compat to 11
  * d/control: Make sure to depends on runtime
  * New upstream version 0.16.0
  * d/symbols: Add new symbols from 0.16.0

 -- Mathieu Malaterre <malat@debian.org>  Mon, 21 Feb 2022 10:20:45 +0100

highway (0.15.1~git20220119.fbe5705-1) experimental; urgency=medium

  * New upstream version 0.15.1~git20220119.fbe5705
  * d/patches: Remove patches applied upstream
  * d/libhwy0: Provide highway as shared libraries
  * d/doc-base: Add missing doc-base registration file

 -- Mathieu Malaterre <malat@debian.org>  Thu, 20 Jan 2022 09:03:02 +0100
