=== debian/control ===
Source: highway
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake (>= 3.13), debhelper (>= 11), libgtest-dev, ninja-build
Standards-Version: 4.6.0
Homepage: https://github.com/google/highway
Vcs-Git: https://salsa.debian.org/debian-phototools-team/highway.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/highway
Rules-Requires-Root: no

Package: libhwy0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (runtime files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the runtime files.

Package: libhwy-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libhwy0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Efficient and performance-portable SIMD wrapper (developer files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the development files.

Package: highway-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: Efficient and performance-portable SIMD wrapper (documentation files)
 This library provides type-safe and source-code portable wrappers over
 existing platform-specific intrinsics. Its design aims for simplicity,
 reliable efficiency across platforms, and immediate usability with current
 compilers.
 .
 This package installs the documentation files.
