=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,11 @@
 #!/usr/bin/make -f
+#export DH_VERBOSE=1
+
+include /usr/share/dpkg/default.mk
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
+
 %:
 	dh $@ --buildsystem=cmake+ninja
 
@@ -7,8 +14,10 @@
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
 endif
 
+# test suite rely on CMAKE_SKIP_RPATH=OFF
 CMAKE_EXTRA_FLAGS += \
- -DBUILD_SHARED_LIBS:BOOL=OFF \
+ -DCMAKE_SKIP_RPATH:BOOL=OFF \
+ -DBUILD_SHARED_LIBS:BOOL=ON \
  -DHWY_WARNINGS_ARE_ERRORS:BOOL=ON \
  -DHWY_SYSTEM_GTEST:BOOL=ON
