=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libjxl-$1\.tar\.gz/ \
  https://github.com/google/highway/tags .*/v?(\d\S+)\.tar\.gz
