## highway 0.17.0

=== debian/changelog ===
highway (0.17.0-4) unstable; urgency=medium

  * d/patches: Fix armhf compilation failure

 -- Mathieu Malaterre <malat@debian.org>  Tue, 28 Jun 2022 11:54:52 +0200

highway (0.17.0-3) unstable; urgency=medium

  * d/rules: Disable Emu128 on armhf for now, revert to Scalar
  * d/patches: Fix unit test on big-endian arches

 -- Mathieu Malaterre <malat@debian.org>  Mon, 27 Jun 2022 16:46:06 +0200

highway (0.17.0-2) unstable; urgency=medium

  * d/patches: cherry-pick a fix for arm64/armhf

 -- Mathieu Malaterre <malat@debian.org>  Wed, 22 Jun 2022 08:47:55 +0200

highway (0.17.0-1) unstable; urgency=medium

  * New upstream version 0.17.0
  * d/patches: Fix symbols mangling issue
  * d/symbols: Update symbols for new release
  * d/control: Bump Std-Vers to 4.6.1 no changes needed
  * d/rules: Remove some CPU extension on i386

 -- Mathieu Malaterre <malat@debian.org>  Tue, 21 Jun 2022 17:13:46 +0200
