=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,14 @@
 ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),armhf))
   # https://github.com/google/highway/issues/495
   CMAKE_EXTRA_FLAGS += -DHWY_CMAKE_ARM7:BOOL=OFF
+  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
+  # https://github.com/google/highway/issues/398#issuecomment-1167331556
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wno-psabi -DHWY_COMPILE_ONLY_SCALAR
+endif
+
+# Disable some extensions on i386 anyway:
+ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),i386))
+  export DEB_CXXFLAGS_MAINT_APPEND = -DHWY_DISABLED_TARGETS='(HWY_SSE4|HWY_SSSE3)'
 endif
 
 # test suite rely on CMAKE_SKIP_RPATH=OFF
